/*
 * ----------------------------------------------------------------------
 * Emulation of S3C2410 Nandflash Controller
 * (C) 2007 Jochen Karrer
 *   Author: Jochen Karrer
 *
 * state: Not implemented
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * ----------------------------------------------------
 */


#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <bus.h>
#include <signode.h>
#include <configfile.h>
#include <s3c2410_nand.h>
#include <sgstring.h>

/* Base address is 0x4e000000 */
#define NFC_NFCONF	((base)+0x00)
#define		NFCONF_NFEN	(1<<15)
#define		NFCONF_INIECC	(1<<12)
#define		NFCONF_NFMCE	(1<<11)	
#define		NFCONF_TACLS_MASK 	(7<<8)
#define		NFCONF_TACLS_SHIFT	(8)
#define 	NFCONF_TWRPH0_MASK	(7<<4)
#define		NFCONF_TWRPH0_SHIFT	(4)
#define		NFCONF_TWRPH1_MASK	(7)
#define		NFCONF_TWRPH1_SHIFT	(0)

#define NFC_NFCMD	((base)+0x04)
#define NFC_NFADDR	((base)+0x08)
#define NFC_NFDATA	((base)+0x0c)
#define	NFC_NFSTAT	((base)+0x10)
#define	NFC_NFECC	((base)+0x14)

